<template>
  <div id="file-upload" class="text-center mb-4">
    <div
      class="mb-4 warning_light_2 border-lg d-flex flex-column justify-center align-center cursor-pointer h-100 w-100 rounded-lg"
      :class="
        currentFile !== undefined && currentFile !== null
          ? 'pa-0'
          : 'px-1 py-16'
      "
      @click="onButtonClick"
    >
      <template
        v-if="
          (currentFile !== undefined && currentFile !== null) ||
          currentVideoUrl ||
          currentImageUrl
        "
      >
        <template v-if="isVideo">
          <div class="box-button-change-file">
            <v-btn
              fab
              depressed
              small
              color="warning"
              @click.prevent.stop="onButtonClick"
            >
              <v-icon small v-if="alertSubmit"> mdi-cancel </v-icon>
              <v-icon small v-else>mdi-cancel</v-icon>
            </v-btn>

            <p
              class="system_white--text family-openSans-semi-bold caption-signbank text-center"
              v-if="alertSubmit"
            >
              {{ alertSubmit }}
            </p>
          </div>

          <template v-if="currentFile !== undefined || currentVideoUrl">
            <video-player
              v-if="currentFile !== undefined"
              :src="currentFile.url"
            />

            <video-player v-else :src="currentVideoUrl" />
          </template>
        </template>

        <template v-else>
          <div class="box-button-change-file">
            <v-btn
              fab
              depressed
              small
              color="warning"
              @click.prevent.stop="onButtonClick"
            >
              <v-icon small v-if="alertSubmit"> mdi-cancel </v-icon>
              <v-icon small v-else>mdi-cancel</v-icon>
            </v-btn>

            <p
              class="system_white--text family-openSans-semi-bold caption-signbank text-center"
              v-if="alertSubmit && currentFile === undefined"
            >
              {{ alertSubmit }}
            </p>
          </div>

          <template
            v-if="
              (currentFile !== undefined && currentFile !== null) ||
              currentImageUrl
            "
          >
            <template v-if="isImage">
              <v-img
                height="100%"
                style="max-height: 250px"
                v-if="currentFile !== undefined"
                :src="currentFile.url"
              ></v-img>

              <v-img v-else height="100%" :src="currentImageUrl"></v-img>
            </template>

            <v-icon v-else size="180px" color="white">
              {{ iconName }}
            </v-icon>
          </template>
        </template>
      </template>

      <template v-else>
        <v-btn fab dark depressed color="warning">
          <v-icon color="white">
            {{ alertSubmit ? "mdi-cancel" : iconName }}
          </v-icon>
        </v-btn>

        <div class="mt-2" v-if="label || alertSubmit">
          <p
            class="system_grey_2--text family-openSans-semi-bold caption-signbank text-center"
            v-if="alertSubmit"
          >
            {{ alertSubmit }}
          </p>

          <span
            v-else
            class="system_grey_2--text text-lowercase family-openSans-semi-bold caption-signbank text-center"
          >
            <span v-html="label"></span>
          </span>
        </div>
      </template>
    </div>
    <v-progress-linear
      v-if="progress_upload"
      :value="progress_upload"
    ></v-progress-linear>
    <input
      ref="uploader"
      class="d-none"
      type="file"
      :accept="acceptedTypes ? acceptedTypes : ''"
      @change="onFileChanged"
      :multiple="false"
    />

    <v-btn
      outlined
      rounded
      color="error"
      @click.prevent.stop="deleteDocuments"
      :loading="loaderDelete"
      v-if="currentFile != undefined"
      class="mb-2"
    >
      <span class="caption-signbank family-openSans-bold">
        {{ $t("buttons.delete") }}
      </span>
    </v-btn>

    <v-btn
      outlined
      rounded
      color="warning"
      @click.prevent.stop="postDocuments"
      :loading="loader"
      v-if="haveNewFile"
      class="mb-2"
      disabled
    >
      <span class="caption-signbank family-openSans-bold">
        {{ $t("buttons.submit") }}
      </span>
    </v-btn>

    <v-btn
      outlined
      rounded
      color="warning"
      @click.prevent.stop="onButtonClick"
      :loading="loader"
      class="mb-2"
      v-else
      disabled
    >
      <span
        class="caption-signbank family-openSans-bold"
        v-if="currentFile === null"
      >
        {{ $t("buttons.select") }}
      </span>
      <template v-else>
        <span
          class="caption-signbank family-openSans-bold"
          v-if="currentFile !== undefined || currentVideoUrl || currentImageUrl"
        >
          {{ $t("buttons.change") }}
        </span>
        <span class="caption-signbank family-openSans-bold" v-else>
          {{ $t("buttons.select") }}
        </span>
      </template>
    </v-btn>
  </div>
</template>

<script>
export default {
  props: [
    "acceptedTypes",
    "label",
    "documents_type_id",
    "currentVideoUrl",
    "currentImageUrl",
    "currentFile",
    "index",
  ],

  data() {
    return {
      loader: false,
      loaderDelete: false,
      form: {
        documents_type_id: null,
      },
      progress_upload: 0,
      response: null,
      files: null,
      alertSubmit: "",
      iconName: "",
      isVideo: false,
      isPDF: false,
      isImage: false,
      haveNewFile: false,
    };
  },

  mounted() {
    this.verifyTypeFile();

    if (this.documents_type_id) {
      this.form.documents_type_id = this.documents_type_id;
    }
  },

  watch: {
    document_type(val) {
      this.form.documents_type_id = val.id;
    },
  },

  methods: {
    verifyTypeFile() {
      if (this.acceptedTypes === "application/pdf") {
        this.iconName = "mdi-cancel";
        this.isPDF = true;
      } else if (this.acceptedTypes === "video/*") {
        this.iconName = "mdi-cancel";
        this.isVideo = true;
      } else if (this.acceptedTypes === ".png, .jpg, .jpeg") {
        this.iconName = "mdi-cancel";
        this.isImage = true;
      } else if (this.acceptedTypes === "image/*") {
        this.iconName = "mdi-cancel";
        this.isImage = true;
      } else if (this.acceptedTypes === "*/*") {
        this.iconName = "mdi-cancel";
      }
    },

    onButtonClick() {
      this.isSelecting = true;

      window.addEventListener(
        "focus",
        () => {
          this.isSelecting = false;
        },
        { once: true }
      );

      this.$refs.uploader.click();
    },

    onFileChanged(e) {
      this.files = e.target.files[0];
      if (this.files) {
        this.alertSubmit = this.$t("global_message_alerts.select_video");
        this.haveNewFile = true;
      } else {
        this.haveNewFile = false;
        this.alertSubmit = "";
      }
    },

    deleteDocuments() {
      this.loaderDelete = true;
      this.$axios
        .delete("documents/" + this.currentFile.id)
        .then(() => {
          this.$toast.success(this.$t("global_message_alerts.success_delete"));
          if (this.index) {
            this.$emit("successDelete", this.index);
          }

          if (!this.index) {
            this.$emit("successDelete");
          }
        })
        .catch(() => {
          this.$toast.error(this.$t("global_message_alerts.error_delete"));
        })
        .finally(() => {
          this.loaderDelete = false;
          this.progress_upload = 0;
        });
    },

    postDocuments() {
      if (this.files) {
        let form = new FormData();
        let returno = false;
        this.loader = true;
        this.$emit("submitStatusLoaderNewFile", this.loader);
        this.alertSubmit = this.$t("global_message_alerts.loading");
        form.append("documents", this.files);
        form.append("platform", this.$config.PLATFORM);
        this.$axios
          .post("documents", form, {
            onUploadProgress: (event) => {
              let progress = Math.round((event.loaded * 100) / event.total);

              this.progress_upload = progress;
            },
            params: {
              document_type_id: this.form.documents_type_id,
            },
          })
          .then((res) => {
            returno = true;
            this.response = res.data.documents;

            if (this.index) {
              this.$emit("successPost", this.response, this.index);
            }
            if (!this.index) {
              this.$emit("successPost", this.response);
            }

            this.$toast.success(
              this.$t("global_message_alerts.success_create")
            );
            this.haveNewFile = false;
          })
          .catch((e) => {
            this.$toast.error(this.$t("global_message_alerts.error_create"));
          })
          .finally(() => {
            this.loader = false;
            this.alertSubmit = "";
            this.$emit("submitStatusLoaderNewFile", this.loader);
          });
      } else {
        this.$toast.error(this.$t("global_message_alerts.select_file"));
      }
    },
  },
};
</script>

<style>
#file-upload .box-button-change-file {
  z-index: 2;
  position: absolute;
}
</style>
